/**************************************************************************
 *
 *	project				 : qtplot
 *
 *	copyright            : (C) 2004 by Michael Neuroth
 *
 * ------------------------------------------------------------------------
 *
 *  $Source: $
 *
 *  $Revision: $
 *
 *	$Log: $
 *	
 *
 ***************************************************************************/
/***************************************************************************
 *																		   *
 * This file is part of the qtplot package (a gnuplot plotting frontend    *
 * for Qtopia and Qt)                                                      *
 *																		   *
 * Copyright (C) 2004 by Michael Neuroth.								   *
 *                                                                         *
 * This program is free software; you can redistribute it and/or modify    *
 * it under the terms of the GNU General Public License as published by    *
 * the Free Software Foundation; either version 2 of the License, or       *
 * (at your option) any later version.                                     *
 *                                                                         *
 ***************************************************************************/

/*
	Speichernt des Ports in Ini-Datei ...
	Kein Abbruch wenn port belegt ist ...

*/

#include "qtplotmainwindow.h"
#include "graphicoperation.h"

#ifdef _with_ptr_list
//#include <qptrvector.h> 
#include <qptrlist.h> 
#else
#include <qlist.h>
#endif

class SimpleBitmapCanvas;
class QCanvas;
class QCanvasView;
class QImage;

class ServerSocket;
class ClientSocket;

class FileDialogS;

#define QTPLOT_PORT_NO	5050		// used by Zaurus 5500: 4242

class qtplotMainWindowImpl : public qtplotMainWindow
{
	Q_OBJECT

public:
	qtplotMainWindowImpl( QWidget* parent = 0, const char* name = 0, WFlags f = WType_TopLevel );
	~qtplotMainWindowImpl();

	void AddGraphicElemtent( GraphicOperation * pGraphOp );
	void EraseGraphicElements();
	void DrawGraphicElements();
	void ClearCanvas();

	void OpenFile( const QString sFileName );
	void ReadGraphicFile( const QString sFileName );
	void ProcessLine( const QString & sLine );
	GraphicOperation * ParseGraphicFileLine( const QString & sLine );
	void Update();
	void UpdateServerSocket();
	void LogLine( const QString & sLine );

public slots:
	virtual void sltActivate();
    virtual void sltTest();
    virtual void sltEraseGraphicElements();
    virtual void sltClearGraphicElements();
    virtual void sltDrawGraphicElements();
    virtual void sltOpenFile();
    virtual void sltClearLogging();
    virtual void sltClearImage();
    virtual void sltAbout();
    virtual void sltExpandImage( bool bNewValue );
    virtual void sltDisableLogging(bool bNewValue );
    virtual void sltConfiguration();
    virtual void sltStartGnuplotShell();
    virtual void sltPrint();

	virtual void sltNewConnection( ClientSocket * pSocket );
	virtual void sltReceivedText( const QString & sLine );
	virtual void sltClosedClientSocket();
	virtual void sltDoImport();

signals:
    void sigActivate();

protected:
	virtual void showEvent( QShowEvent * pShowEvent ); 
	virtual void resizeEvent( QResizeEvent * pEvent );

private:
	SimpleBitmapCanvas *	m_pCanvas;
	QCanvasView *			m_pView;
	QImage *				m_pImage;
	bool					m_bDisableLogging;

	QString					m_sHostname;
	int						m_iPortnumber;

	GraphicEnv *			m_pGraphEnv;

	ServerSocket *			m_pServerSocket;

#ifdef _with_ptr_list
	//QPtrVector<GraphicOperation>	m_aGraphOpContainer;
	QPtrList<GraphicOperation>		m_aGraphOpContainer;
#else
	QList<GraphicOperation>			m_aGraphOpContainer;
#endif

#ifdef ZAURUS
	FileDialogS *			m_pExportFileDlg;
	QString					m_sLastDirectory;
#endif
};

